// ●リスト5::Proxyの基本
// ハンドラオブジェクト
var handler = {
  // (d1)プロパティの取得をトラップするメソッド
  get(target, key, receiver) {
    // target: obj
    // receiver: proxy
    console.log('Proxy GET:', key);
    // (d2)ここで返した値がプロパティの値になる
    return target[key];
  }
};
// 対象オブジェクト
var obj = {foo: 1};
// (d3)Proxyオブジェクトの生成
var proxy = new Proxy(obj, handler);
console.log(proxy.foo);
// Proxy GET: "foo"
// 1
console.log(proxy.bar);
// Proxy GET: "bar"
// undefined
