// ●リスト6::Proxyによる実行時の型チェック
function createTypeSafeObject(obj) {
  return new Proxy(obj, {
    set(target, key, value, receiver) {
      var currentType = typeof target[key];
      var newType = typeof value;
      if (key in target && currentType !== newType) {
        throw new Error(`${key} requires a ${currentType}!`);
      } else {
        return Reflect.set(target, key, value, receiver);
      }
    }
  });
}
var person = {
  name: "Bob",
  age: 20
};
person = createTypeSafeObject(person);
person.name = "John"; // OK
person.age = true; // Error: age requires a number!
