// ●リスト3::Promise.allを使った非同期処理
function getAllItems() {
  return getUrl("/items").then(list => {
    // 並列でのリクエスト実行
    return Promise.all(list.map(item => {
      return getUrl("/items/" + item.id);
    }));
  });
}

function getUrl(url) {
  return new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.onload = () => {
      if (xhr.status === 200) {
        resolve(xhr.statusText);
      } else {
        // (d1)エラーの場合rejectを呼ぶ
        reject(new Error(xhr.statusText));
      }
    };
    xhr.onerror = () => {
      // (d2)エラーの場合rejectを呼ぶ
      reject(new Error(xhr.statusText));
    };
    xhr.send();
  });
}
