// ●リスト4::Generatorによる非同期処理
function *getFirstItem() {
  var items = yield getUrl("/items");
  var item = yield getUrl("/items/" + items[0].id);
  return item;
}

// 本体側からの呼び出し
var co = require("co");
co(function*() {
  try {
    var item = yield getFirstItem();
    someProcess(item);
  } catch (e) {
    console.error(e);
  }
});

function getUrl(url) {
  return new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.onload = () => {
      if (xhr.status === 200) {
        resolve(xhr.statusText);
      } else {
        // (d1)エラーの場合rejectを呼ぶ
        reject(new Error(xhr.statusText));
      }
    };
    xhr.onerror = () => {
      // (d2)エラーの場合rejectを呼ぶ
      reject(new Error(xhr.statusText));
    };
    xhr.send();
  });
}
