// ●リスト6::HTTP GETリクエストを送る関数
function getUrl(url) {
  return new Promise((resolve, reject) => {
    var xhr = new XMLHttpRequest();
    xhr.open("GET", url);
    xhr.onload = () => {
      if (xhr.status === 200) {
        resolve(xhr.statusText);
      } else {
        // (d1)エラーの場合rejectを呼ぶ
        reject(new Error(xhr.statusText));
      }
    };
    xhr.onerror = () => {
      // (d2)エラーの場合rejectを呼ぶ
      reject(new Error(xhr.statusText));
    };
    xhr.send();
  });
}

getUrl("/items").then(res => {
  // (d3)エラーの場合は呼ばれない
  var items = JSON.parse(res);
  someProcess(items);
}).catch(e => {
  // (d4)エラーの場合だけ呼ばれる
  console.error(e);
})
